;==================
;    Initalize
;==================
;Sets up game!!!

Initalize:
MainMenu:
    ;xor a
    ;ld (InGame),a
    ld hl,TitlePic
    ld de,_plotSScreen
    call DispRLE
    call IonFastCopy
    ld b,0
MainMenuLoop:
    call WaitKey
    cp K_SECOND
    jr z,MMDone
    cp K_ENTER
    jr z,MMDone
    ;cp K_LEFT
    ;jr z,MMSelect
    ;cp K_RIGHT
    ;jr z,MMSelect
    ;cp K_UP
    ;jr z,MMSelect
    ;cp K_DOWN
    ;jr z,MMSelect
    ;cp K_ALPHA
    ;jr z,MMSelect
    cp K_EXIT
    jp z,Quit2
    cp K_F3
    jr z,LevelCheat
    jr MainMenuLoop
LevelCheat:
    call ResetGame
    ld a,99
    ld (OnLevel),a
    jp ContinueNewGame


;MMSelect:
;    ld a,b
;    xor 1
;    ld b,a
;InvertMMItem:
;    push hl
;    push bc
;    push de
;    ld b,14
;    ld de,13                        ;9
;    ld hl,_plotSScreen+((44*16)+8)      ;536
;InvertMMItemLoop:
;    ld a,(hl)
;    xor %00000111
;    ld (hl),a
;    inc hl
;    ld a,(hl)
;    cpl
;    ld (hl),a
;    inc hl
;    ld a,(hl)
;    cpl
;    ld (hl),a
;  inc hl
;    ld a,(hl)
;    xor %11111100
;    ld (hl),a
;    add hl,de
;    djnz InvertMMItemLoop
;    call IonFastCopy
;    pop de
;    pop bc
;    pop hl
;    jr MainMenuLoop
MMDone:
;    ld a,b
;    or a
;    jp z,RestoreGame
NewGame:
    call ResetGame
    call SetInitalLevel
ContinueNewGame:
    ;Load Level
    call NewLevel
    ;Save level gfx
    call DrawMap
    call SwapAPD
    
    ;Scroll the Display
    jp ScrollUp


ResetGame:
    ;Reset Game by filling all game ram with 0's
    ld hl,Vars
    ld de,Vars+1
    ld bc,EndOfVars-Vars-1
    ld (hl),0
    ldir
    
    ;5 Lives and 3 Credits
    ld a,5
    ld (Lives),a
    ld (ScoreUpdateFlag),a
    ld a,3
    ld (Credits),a

    xor a
    ld (SavedFlag),a
    
    call MakeBlackRight
        
    jp SwapAPD
    
SetInitalLevel:
    call RoundSelect
SetInitalLevel2:
    ld (OnLevel),a
    ld (ContinueLevel),a
    ld (StartLevel),a
    ret

;RestoreGame:
;    ld a,(SavedFlag)
;    or a
;    jp z,NewGame
;
;    xor a
;    ld (SavedFlag),a
;    
;    
;    ld a,(OnLevel)
;    call GetMapOnly
;    call SwapAPD
;    call RenderScreenFull
;    call SwapAPD
;    ;Scroll the Display
;    call ScrollUp
;    jp DispScore

RoundSelect:
;If record<19 don't bother, just start the game.
    ld a,(TodaysRecord)
    cp 19
    jr nc,ProceedRoundSelect
    xor a
    ret
ProceedRoundSelect:
;Max round = record\10*10-9
    ld h,0
    ld l,a
    inc l
    call _divHLby10
    ld h,10
    call _HtimesL
    ld a,l
    sub 9
    ld (_OP2),a
;Black the screen
    call BlackScreen
;Dispaly "Select a Round"
    ld hl,tSelect
    ld de,$1010
    call FastVPuts
;Set inital round (1)
    ld a,1
    ld (_OP2+1),a
;Draw the menu, then scroll it on
    call RoundSelectDraw
    call SwapAPD
    call ScrollUp
RoundSelectLoop:
    call RoundSelectDraw
    call WaitKey
    ld hl,_OP2+1
    cp K_LEFT
    call z,RoundSelectLeft
    cp K_RIGHT
    call z,RoundSelectRight
    cp K_SECOND
    jr z,RoundSelectConfirm
    cp K_ENTER
    jr z,RoundSelectConfirm
    cp K_EXIT
    jp z,Quit
    jr RoundSelectLoop
RoundSelectConfirm: 
    call SwapAPD
    ld a,(_OP2+1)
    dec a
    ret
RoundSelectLeft:
    ld a,(hl)
    sub 10
    ld (hl),a
    ret nc
    ld a,(_OP2)
    ld (hl),a
    ret
RoundSelectRight:
    ld a,(hl)
    add a,10
    ld (hl),a
    dec hl
    ld b,(hl)
    inc hl
    inc b
    cp b
    ret c
    ld (hl),1
    ret


RoundSelectDraw:
    ;Clear the line
    ld hl,(30*16)+_plotSScreen
    ld de,(30*16)+1+_plotSScreen
    ld bc,(12*16)-1
    ld (hl),$FF
    ldir
    ;Set Cursor's position
    ld hl,(32*256)+30
    ld (_penCol),hl
    ld a,'<'
    call _vputmap
    ld a,48
    ld (_penCol),a
    ld a,'>'
    call _vputmap
    ld a,38
    ld (_penCol),a
    ld a,(_OP2+1)
    call vDispA
    jp IonFastCopy


;=====================================================
;  WaitKey- Waits and gets a key into register a
;=====================================================
;Output: A=key pressed
WaitKey:
    res alt_int,(iy+exceptionflg)
    call _getky
    call _getky
WKA_loop:
  HALT
  call _getky
  or a
  jr z, WKA_loop
  push af
  ld a,r
  ld (randdata1),a
  pop af
  set alt_int,(iy+exceptionflg)
  ret

;=============
;  ReadKeys
;=============
ReadKeys:
;Check for Clear
    ld a,255
    out (1),a
    ld a,KeyRow_Top
    out (1),a
    in a,(1)
    cp KMode
    jp z,SaveAndQuit
;Check for Plus, you rotten cheater :)
    cp KPlus
    call z,NextLevel
    
;Do stuff for freshly hit buttons
    ld a,(jJump)
    or a
    ld a,0
    jr nz,$+4
    ld a,1
    ld (jJumpPress),a
    ld a,(jBubble)
    or a
    ld a,0
    jr nz,$+4
    ld a,1
    ld (jBubblePress),a
    
;Read arrows
    ld a,255
    out (1),a
    ld a,KeyRow_Pad
    out (1),a
    in a,(1)
    cpl
    ld b,a
    and KILeft
    ld (jLeft),a
    ld a,b
    and KIRight
    ld (jRight),a
    ld a,b
    and KIUp
    ld (jJump),a
;Read 2nd,Mode,Del...
    ld a,255
    out (1),a
    ld a,KeyRow_Top
    out (1),a
    in a,(1)
    cpl
    ld b,a
    and KI2nd
    ld (jBubble),a
   ld a,b
   and KIDel
   call nz,PauseGame
;Read Alpha and on...
    ld a,255
    out (1),a
    ld a,KeyRow_1
    out (1),a
    in a,(1)
    cpl
    ld b,a
    and KIAlpha
    ld hl,jJump
    or (hl)
    ld (hl),a
    ld a,b
    and KIMath
    call nz,PowerOff
    ret

;==============
;  Gameloop!
;==============
GameLoop:
;Read Keyboard 
    
    xor a
    ld (IntCounter),a
    ;inc a
    ;ld (InGame),a    
    call ReadKeys  
    
;Handle Game
    call ModifyCode      ;Modify code (powerups)
    call HandlePits      ;Bubbles can come out of the Holes
    call HandleEnemies   ;Move the objects  
    call BackgroundCode  ;Background stuff (popping bubbles...)

;Output
    ld a,(PopUpLife)
    or a
    call nz,HandlePopUpScore
    
    ld a,(ScoreUpdateFlag)
    or a
    call z,CopyAPD
    or a
    call nz,DispScore

    call InvincibleBub

    call DrawSprites
    ld bc,(BigspriteY)
    xor a
    or b
    or c
    call nz,Disp16Sprite
    
    ld hl,SpriteTable+2
    res 7,(hl)

DelayLoop:
    ld a,(IntCounter)
    cp 5
    jr nc,BreakDelayLoop
    halt
    jr DelayLoop

BreakDelayLoop:
    call IonFastCopy
;Loop back
    jp GameLoop

    
;=======================
;   RenderScreenFull
;=======================
RenderScreenFull:   
    call DisplayOverlay
    jp DrawSprites

;=======================
;  InvincibleBub
;=======================
InvincibleBub:
    ld ix,SpriteTable
InvincibleBob2:
    ld a,(ix+3)
    dec a
    ret nz

    ld a,(ix+6)
    or a
    ret z
    dec a
    ld (ix+6),a
    
    ld a,(Timer)
    and 1
    ret z
    ld a,(ix+2)
    or 128
    ld (ix+2),a
    ret
    
;=======================
;  HandlePopUpScore
;=======================
HandlePopUpScore:
    dec a
    ld (PopUpLife),a
    ret nz
    ld a,1
    ld (ScoreUpdateFlag),a
    ret

;=============
;  BubRandom
;=============
bbRand:  ;just a bunch of other names
bbRandom:
BubRand:
bubRandom:
BubRandom:
RandA:
    ld a,$94
    push hl
RandHL:
    ld hl,$4C79
    inc l
    dec h
randdata1 = RandA+1
randdata2 = RandHL+1
    rlc h
    ld (randdata2),hl
    rlca
    rlca
    sub h
    add a,l
    pop hl
    ld (randdata1),a
    srl a   
    ret

bubRandomize:
    ld (randdata1),a
    ld (randdata2),hl
    ld (randData),hl
    ret

bubRandom2:
    push hl
    call BubRandom
    ld h,a
    call BubRandom
    ld l,a
    ld a,b
    call _divHLbyA
    pop hl
    ret
    

;===============
;  DispScore
;===============
DispScore:
;Score doesn't need to be updated next frame
    xor a
    ld (ScoreUpdateFlag),a
;Draw the Score, Lives, and extend letters
    call DisplayOverlay
;Save the screen
    call Copy2APD
    ret
DisplayOverlay:
;Redraw the bloody map
    call DrawMap
;Cursor = (0,0)
;Display Score, Lives, Extends, Level#...
    call DispScore2
    call DispLives
    call DispExtend
;Check if displaying PopupScore as well
    ld a,(PopUpLife)
    or a
    call nz,DispPopupScore

    call DispLevelNo
    ret
DispLevelNo:
    ld hl,5*256+98
    ld (_penCol),hl
    ld hl,LevelTxt
    call _vputs

    ld hl,11*256+127
    ld (_penCol),hl
    ld a,(OnLevel)
    inc a
    jp vDispA

DispExtend:
    ld hl,Player+(8*ExtendBubble)
    ld bc,$0608
DispExtendLoop:
    push hl
    ld hl,ExpTable
    ld a,b
    cpl
    add a,7
    ld d,0
    ld e,a
    add hl,de
    ld a,(hl)
    ld hl,ExtendFlags
    and (hl)

    
    pop hl
    push hl
    push bc
    jr z,NoDispExtendLetter
    ld b,0
    ld a,8
    call RepSpr
;   call PutSprClpAND
NoDispExtendLetter:
    pop hl
    ld de,8
    add hl,de
    inc hl
    ld b,h
    ld c,l
    pop hl
    add hl,de
    djnz DispExtendLoop
    
    
    
    
    
    ret

DispLives:
;Display All Natural(TM) Lives Counter
    ;ld hl,LivesCounterGfx
    ;ld bc,$4800
    ;ld a,6
    ;call RepSpr
    ;ld bc,$5000
    ;ld a,6
    ;call RepSpr
    ld hl,23*256+98
    ld (_penCol),hl
    ld hl,LivesTxt
    call _vputs
    ld hl,29*256+127
    ld (_penCol),hl
    ld a,(Lives)
    jp vDispA

DispPopupScore:
    ld hl,(PopUpX)
    ld (_penCol),hl
    ld hl,(PopUpScore)
    ld de,_OP1+6
    xor a
    ld (de),a
    dec de
    ld a,'0'
    ld (de),a
DispPSLoop:
    call _divHLby10
    add a,'0'
    dec de
    ld (de),a
    ld a,h
    or l
    jr nz,DispPSLoop
    ex de,hl
    call _vputs
    ret
    
DispScore2:
    ld hl,40*256+98
    ld (_penCol),hl
    ld hl,ScoreTxt
    call _vputs
    ld hl,46*256+127
    ld (_penCol),hl
    call ConvScore
    
    ld a,c
    add a,a
    add a,a
    ld c,a
    ld a,(_penCol)
    sub c
    ld (_penCol),a
    
    jp _vputs                 ; CHANGED!!!!!!!!
    ;ret
ConvScore:
    ld hl,_OP1
    ld de,_OP1+1
    ld bc,19
    ld (hl),0
    ldir
DispScore2_Mod:
    ld hl,(Score+2)
    ld ix,(Score)
    call Bin32ToBCD
    ld hl,_OP1
    ld b,5
    jp BCDToStr

CheckLast2ScoreDigits:
    call ConvScore
CL2Loop:
    inc hl
    ld a,(hl)
    or a
    jr nz,CL2Loop
    dec hl
    dec hl
    ld a,(hl)
    dec hl
    ld b,(hl)
    cp b
    ret

        
;Input: 32-bit number in HLIX (in that order of significance)
;       Change TEMP to a temporary location with 5 bytes free
;       (these bytes need to be zeroed out before each use!)
;Output: DE->TEMP, which has the BCD representation of HLIX
Bin32ToBCD:
    ld  c,33
B32loop:
    ld  b,5
    dec c
    ret z
    ld  de,_OP1+13+5
    add ix,ix
    adc hl,hl
B32daa:
    dec de
    ld  a,(de)
    adc a,a
    daa
    ld  (de),a
    djnz    B32daa
    jp  B32loop



;Input: DE->BCD representation of a number
;       HL->location to output string
;       B=number of bytes in this BCD number
;Output: HL->output string

BCDToStr:
    ld c,0
    push    hl
    ex  de,hl
BCDzero:
    ld  a,(hl)
    inc hl
    dec b
    jr  z,BCDdone
    or  a
    jr  z,BCDzero
BCDdone:
    dec hl
    inc b
    ld  a,'0'
    rld
    cp  '0'
    jr  nz,BCDrrd
    jr  BCDskip
BCDloop:
    rld
BCDrrd:
    ld  (de),a
    inc de
    inc c
BCDskip:
    rld
    ld  (de),a
    inc de
    inc c
    inc hl
    djnz    BCDloop
;Modification to add 0 to the end of the string...
    ld a,'0'
    ld (de),a
    inc de
    inc c
    xor a
    ld  (de),a
    pop hl
    ret

;===============
;    GetMap
;===============
;Loads a new map
;Input: A=New map
GetMap:
GetMapOnly:
    call FindMap
    ret c
    ld a,(hl)
    and 15
    inc a
    add a,a
    add a,10
    
    ld c,a
    ld b,0
    add hl,bc
    inc hl
    jp DecompressMap
NewLevel:
    cp levelcount
    jp nc,BadEnd

    ld hl,SpriteTable
    ld de,SpriteTable+1
    ld bc,EndOfSprites-SpriteTable-1
    ld (hl),0
    ldir
    ld de,SpriteTable
    ld hl,DefaultBubTable
    ld bc,4
    ldir
    
    call FindMap
    ret c
    ld a,(hl)
    and 15
    inc a
    ld (EnemyCount),a
    ld a,(hl)
    and %11110000
    rra
    rra
    rra
    rra
    ld (Ammo),a
    inc hl
    ld a,(hl)
    ld (Holes),a
    inc hl

    ld de,Hurry
    ldi
    ldi
    ld de,PopTime
    ldi

    ex de,hl
    call NewPattern
    ex de,hl
    
    inc hl

    ld a,(EnemyCount)
    ld b,a
    push bc
    ld c,(hl)
    inc hl
    ld b,(hl)
    sla b
    inc hl
    ld a,Item1
    call CreateSprite
    ld (ix+2),0
    ld c,(hl)
    inc hl
    ld b,(hl)
    sla b
    inc hl
    ld a,Item2
    call CreateSprite
    ld (ix+2),0
    pop bc
CreateEnemiesLoop:
    push bc
    ld a,(hl)
    and $7F
    ld c,a
    ld a,(hl)
    and $80
    rlca
    rlca
    ld e,a
    inc hl
    ld a,(hl)
    and $1F
    add a,a
    neg
    ld b,a
    ld a,(hl)
    and $E0
    rra
    rra
    add a,Enemies
    add a,e
    inc hl
    call CreateSprite
    ld (ix+3),FallingEnemy
    pop bc
    djnz CreateEnemiesLoop
    push hl
    call SpecialLevels
    pop hl
    jp DecompressMap


;    FindMap - Seeks a map
;Input: A=Map number
;Output: HL=Compressed map pointer, carry flag set on failure
FindMap:
    ld hl,Maps
    or a
    ret z
    ld b,a
FMLo_OP1:
    push bc
    ld a,$FF
    ld bc,384
    cpir
    pop bc
    djnz FMLo_OP1
    ret

;    DecompressMap - Decompresses 5.3 bit RLE   
;input: hl=pointer to compressed data
DecompressMap:
    ;Destination = Level ram
    ld de,level
DecompressLoop:
    ;Get the byte
    ld a,(hl)
    ;Quit on $FF
    cp $FF
    jr z,ConvertMap
    ;Fliter off the length, increment, and store into b
    and %00011111
    inc a
    ld b,a
    ;Get the byte again, and filter out the tile into a
    ld a,(hl)
    rlca
    rlca
    rlca
    and %00000111
DecompLoop2:
    ;Store a byte
    ld (de),a
    ;Next byte to store...
    inc de
    ;Repeat
    djnz DecompLoop2
    ;Next byte
    inc hl
    ;Repeat
    jr DecompressLoop
ConvertMap:
    ld de,15*24+map+1
    ld hl,15*24+map
    ld bc,23
    ld (hl),0
    ldir
    ld de,14*24+map
    ld hl,13*22+map
    ld b,14
    xor a
ConvertMapLoop:
    push bc
    ld bc,22
    ld (de),a
    inc de
    ldir
    ld (de),a
    inc de
    ld bc,-44
    add hl,bc
    ld bc,-48
    ex de,hl
    add hl,bc
    ex de,hl
    pop bc
    djnz ConvertMapLoop
    push de
    pop hl
    inc de
    ld (hl),a
    ld bc,23
    ldir
MakeHoles:
    ld hl,Holes
    ld de,map +6+(0*24)
    ld c,1
    call MakeHole
    ld de,map +14+(0*24)
    call MakeHole
    ld de,map +6+(15*24)
    call MakeHole
    ld de,map +14+(15*24)
MakeHole:
    ld a,(hl)
    and c
    jr z,NoUpHole
    ld b,1
NoUpHole:
    sla c
    ld a,(hl)
    and c
    jr z,NoDownHole
    ld b,4
NoDownHole:
    sla c
    ld a,b
    ld b,4
MakeHoleLoop:
    ld (de),a
    inc de
    djnz MakeHoleLoop
    ret

SpecialLevels:
    ld a,(OnLevel)
    cp 99
    jr z,Setup100
    ret
Setup100:
    ld ix,SpriteTable
    ld bc,8
Setup100CrappyLoop:
    add ix,bc
    ld a,(ix+3)
    cp Item1
    jr nz,Setup100CrappyLoop
    ld a,ThunderPotion
    ld (ix+3),a
    ld (ix+2),a
    add ix,bc
    ld (ix+3),a
    ld (ix+2),a
    add ix,bc
    ld (ix+0),40
    ld (ix+1),-16
    ld (ix+2),0
    ld (ix+3),SuperDrunk
    ret

;==================
;    ModifyCode
;==================
;Modifies AI code depending on items collected
ModifyCode:

    ld hl,BonusFlags
    ;Candy Code
    bit b_candy,(hl)
    ld a,14
    ld b,$DC  ;call c 
    jr z,MCNoCandy
    ld a,6
    ld b,$CD  ;call
MCNoCandy:
    bit b_shoes,(hl)
    jr z,NoCandyTimes2
    add a,a
NoCandyTimes2:
    ld (CandyModify+1),a
    ld a,b
    ld (FastPrebubble),a
    ;Cross Code
    bit b_cross,(hl)
    ld a,Prebubble
    jr z,MCNoCross
    ld a,Fireball
MCNoCross:
    ld (CrossModify+1),a
    ret
    
;===================
;  PopupHLScore
;===================
PopUpHlScore:
    push hl
    ld (PopUpScore),hl
    call CountHLDigits
    inc b
    add a,b
    add a,a
    ld b,a
    ld a,(SpriteTable+0)
    add a,4
    ld c,a
    add a,b
    cp 92
    jr c,PopUpXNotTooBig
    ld a,92
PopUpXNotTooBig:
    sub b
    sub b
    jr nc,PopUpXNotTooSmall
    xor a
PopUpXNotTooSmall:
    ld hl,PopUpX
    ld (hl),a
    ld a,(SpriteTable+1)
    sub 8
    jr nc,PopUpYNotTooSmall
    xor a
PopUpYNotTooSmall:
    cp 56
    jp c,PopUpYNotTooBig
    ld a,56
PopUpYNotTooBig:
    inc hl
    ld (hl),a
    ld a,32
    inc hl
    ld (hl),a
    pop hl
    jr AddHlToScore
CountHLDigits:
    ld b,1
CountHLDigitsLoop:
    call _divHLby10
    ld a,h
    or l
    ret z
    inc b
    jr CountHLDigitsLoop

;==================
;   AddHLToScore
;==================
;Adds HL to Score
Add1ToScore:
    ld hl,1
AddHlToScore:
    ld de,Score
    ld a,(de)
    add a,l
    ld (de),a
    inc de
    ld a,(de)
    adc a,h
    ld (de),a
    inc de
    ld a,(de)
    adc a,0
    ld (de),a
    inc de
    ld a,(de)
    adc a,0
    ld (de),a
    inc de
    inc a
    ld (ScoreUpdateFlag),a
    ret

;=============
;   iFruit
;=============
;Sets new variables when you kill an enemy
iFruit:
    ;1 less enemy left
    ld hl,EnemyCount
    ld a,(hl)
    dec a
    ld (hl),a
    cp 1
    call z,LastEnemy
    or a
    jr nz,EnemiesStillAlive
    call NoMoreEnemies
EnemiesStillAlive:
    ld a,(ix+6)
    or a
    jr nz,NotFruit
    
    ld a,16
    ld (PopCount),a
    
    ld hl,FruitCount
    ld a,(hl)
    add a,8
    ld (ix+6),a
    inc (hl)
    
    
    
    
    ld a,(ix+6)
    or a
NotFruit:   
    
    
    
    ret

LastEnemy:
    ld hl,SpriteTable+15
    ld de,8
    ld b,SpriteCount-1
LastEnemyLoop:
    add hl,de
    set 6,(hl)
    djnz LastEnemyLoop
    ret

NoMoreEnemies:
    call CalcNextBonusFruit
    
    ;Check if last 2 Score digits are same
    push ix
    call CheckLast2ScoreDigits
    pop ix
    
    push ix
    ld hl,0
    
    ;Reset Timer and stuff 0 into hl
    ld (Timer),hl

    ;All bubbles become fruit if last 2 Score digits same
    jr z, LoadFruit
    
    ;Do you have the cane?
    ld a,(BonusFlags)
    bit b_cane,a

    ;If not just pop the bubbles!
    jr z, DontLoadFruit

LoadFruit:  
    ;Turn bubbles into FRUIT!!!
    call BubRandom
    and 15
    add a,Fruit
    ld h,a            ;IX+5
    ld l,FallingFruit  ;IX+6

    ;Make a huge item if you have the cane
    push hl
    ld hl,BonusFlags
    bit b_cane,(hl)
    call nz,MakeHugeItem
    pop hl

    
DontLoadFruit:  ;Just pop the bubbles instead?
    ld ix,SpriteTable+8
    ld de,8
    ld b,SpriteTotal
MakeEnemiesBubblesLoop:
    ld a,(ix+3)
    cp Bubble
    jr nz,MEBNotABubble
    ld (ix+4),255
    ld (ix+5),h
    ld (ix+6),l
    set 7,(ix+7)
    res 6,(ix+7)
MEBNotABubble:
    add ix,de
    djnz MakeEnemiesBubblesLoop
    
    pop ix

    ret

;===================
;  BackgroundCode
;===================
BackgroundCode:
    call FruityTests
    call BonusLifeCheck
    call CheckEnd
    ret

BonusLifeCheck:
    
    ret

CalcNextBonusFruit:
;Make CurBonusFruit:
  ;First, the offset of the bonusfruit variable
  ld de,CurBonusFruit
  ;First, get the Timer/??
  ld hl,(Timer)
  ld a,64
  call _divHLbyA
  ld a,h
  or a
  jr nz,MFTookTooLong
  ld a,l
  dec a
  cp 16
  jr nc,MFTookTooLong
  cpl 
  add a,18
  jr MFDone
    ;If you took WAY too long, no bonus at all.
MFTookTooLong:  
  xor a
;  jr MFDone
;  ;If you took long, you get a lame vegetable
;MFTookLong:
;   and 1
;   inc a
MFDone:
  ;Store the next bonusfruit
  ld (de),a
    ret

    
PointA2HLInd:
  add a,a
PointHLInd:
  ld d,0
  ld e,a
  add hl,de
Ldhlind:
    ld a,(hl)
    inc hl
    ld h,(hl)
    ld l,a
    ret

SetAHL:
    add a,a
    add a,a
    add a,a
    or $C6
    ld (SetAHLModify+1),a
SetAHLModify:
    set 0,(hl)
    ret


FruityTests:
    ld hl,FruitCount
    ld a,(hl)
    or a
    ret z
    dec hl
    ld a,(hl)
    dec a
    ld (hl),a
    ret nz
    inc hl
    ld a,(hl)
    ld (hl),0
    ld b,a
    sub 2
    jr c,NoExtendLetters
    ld hl,Extend
    add a,(hl)
    ld (hl),a
NoExtendLetters:
    ld a,b
    ld hl,PopScoreTable-2
    call PointA2HLInd
    jp PopUpHlScore

CheckEnd:
    ld a,(EnemyCount)
    or a
    ret nz
    ld a,(Timer+1)
    cp 1
    ret nz
    ;NEXT LEVEL!!!
NextLevel:
  call RenderScreenFull
    call SwapAPD
    
    ;Reset Timer
    ld hl,0
    ld (Timer),hl

    ld a,(BonusFlags)
    and b_levmask
    ld (BonusFlags),a
    ld a,(OnLevel)
    inc a
    ld (OnLevel),a
    ld hl,TodaysRecord
    ld b,(hl)
    cp b
    jr c,NoNewLevelRecord
  ld (hl),a
NoNewLevelRecord:
    call NewLevel
    call DrawMap
    ld hl,0
    ld (_penCol),hl
    call DispScore2
    ld a,3
    ld (ScoreUpdateFlag),a
    call SwapAPD
    call ScrollUp
    ret
    
;================
;    Bad End!
;================
BadEnd:
    call BlackScreen
    
    ld de,10*256+30
    ld hl,tBadEnd1
    call FastVPuts
    ld de,21*256+8
    ld hl,tBadEnd2
    call FastVPuts
    call SwapAPD
    call ScrollUp
    call WaitKey
    jp Quit

;================
;   Game Over
;================
GameOver:
    ;xor a
    ;ld (InGame),a
    pop af
    pop af
    call RenderScreenFull
    call SwapAPD
    call BlackScreen
    call CheckHighScore
    
    ld de,27*256+30
    ld hl,tGameOver
    call FastVPuts
    
    call SwapAPD
    call ScrollUp
    
ContinuePrompt:
    ld de,37*256+26
    ld hl,tCredits
    call FastVPuts
    ld a,(Credits)
    or a
    jp z,NoContinues
    add a,'0'
    call _vputmap
    ld de,47*256+33
    ld hl,tContinue
    call FastVPuts
    ld de,55*256+33
    ld hl,tEnd
    call FastVPuts
        
    call Copy2APD
    ld hl,Cursor
    ld bc,26*256+48
    ld e,0
ContinueLoop:
    push hl
    push bc
    push de
    call PutSprClpAND
    call IonFastCopy
    call CopyAPD
    call WaitKey
    pop de
    pop bc
    pop hl
    cp K_SECOND
    jr z,contProceed
    cp K_ENTER
    jr z,contProceed
    cp K_LEFT
    jr z,contChange
    cp K_RIGHT
    jr z,contChange
    cp K_UP
    jr z,contChange
    cp K_DOWN
    jr z,contChange
    cp K_ALPHA
    jr z,contChange
    cp K_EXIT
    jp z,Quit
    jr ContinueLoop
contChange:
    ld a,e
    xor 1
    ld e,a
    ld a,c
    xor 56^48
    ld c,a
    jr ContinueLoop
contProceed:
    ld a,e
    or a
    jp nz,Quit
    ld hl,(OnLevel)
    push hl

    ld a,(Credits)
    dec a
    ;reset
    ld hl,Vars
    ld de,Vars+1
    ld bc,EndOfVars-Vars-1
    ld (hl),0
    ldir
    ld (Credits),a
    pop hl
    ld a,5
    ld (Lives),a
    ld (ScoreUpdateFlag),a
    ld a,l
    ld (OnLevel),a
    ld (ContinueLevel),a
    call NewLevel
    call DrawMap
    call Copy2APD
    
    call BlackScreen
    
    call ScrollUp
    jp GameLoop

NoContinues:
    call WaitKey
    jp Quit



;================
;   FastVPuts
;================
FastVPuts:
    ld (_penCol),de
    jp _vputs
    ;ret



;=========================================
;  NewPattern - Loads a new wall style
;=========================================
NewPattern:
    ld hl,Tile
    call NewPattern2
    inc de
NewPattern2:
    ld a,(de)
    and %11110000
    ld c,a
    rra
    rra
    rra
    rra
    or c
    ld c,a
    call NewPattern3
    ld a,(de)
    and %00001111
    ld c,a
    add a,a
    add a,a
    add a,a
    add a,a
    or c
    ld c,a
NewPattern3:
    ld (hl),a
    inc hl
    inc hl
    inc hl
    inc hl
    or %00001111
    ld (hl),a
    inc hl
    inc hl
    inc hl
    inc hl
    ld a,c
    or %11110000
    ld (hl),a
    ld bc,-7
    add hl,bc
    ret


;=======================
;  CheckHighScore
;=======================
CheckHighScore:
    ret
