;Bubble Bobble 86
;
; Original for the TI-83 by Dwedit (Dan Weiss)
;    bubblebobble@dwedit.cjb.net
;
; http://bubblebobble.dwedit.cjb.net/
;
; TI-86 port by Andreas Finne
;    afinne@saunalahti.fi
;

#include "ti86asm.inc"

;============
;  Equates!
;============
SpriteTotal = 64
SpriteCount = SpriteTotal
numSprite = SpriteTotal

DefaultXSpriteHeight = 8



.org _asm_exec_ram

    nop
    jp Start
    .dw 0
    .dw tTitle
    
;===============
;  Game Stuff
;===============
;Description
tTitle: .db "Bubble Bobble v0.960",0


;===============
;  Game Code!
;===============
Start:
    call _flushallmenus
    call _runindicoff
    call _clrScrn
    call InstallInt
    set textInverse,(iy+textflags)
    set textwrite,(iy+new_grf_flgs)
    
    ld hl,datastring
    rst 20h
    rst 10h
    jp c, nofile
    ld a,b
    ex de,hl
    call _ahl_plus_2_pg3
    call _set_abs_src_addr
    ld a,1
    ld hl,$0100
    call _set_abs_dest_addr
    xor a
    ld hl,11542
    call _set_mm_num_bytes
    call _mm_ldir
    call _ram_page_1

    ld (BackupSP),sp              ;Save Stack Pointer
RestartGame:
    call Initalize                ;Set up game
    jp GameLoop                   ;Play!
SaveAndQuit:
    ld a,1
    ld (SavedFlag),a
Quit:
    ld sp,0         ;Self modify code
    call SwapAPD
    ld hl,TitlePic
    ld de,_plotSScreen
    call DispRLE
    call SwapAPD
    call ScrollUp
    jr RestartGame
Quit2:
    ld sp,(BackupSP)
    
    
    res textInverse,(iy+textflags)
    res textwrite,(iy+new_grf_flgs)
    res alt_int,(iy+exceptionflg)
    set graphdraw,(iy+graphflags)
    call _clrScrn
BackupSP = Quit+1 ;Pointer

    ret             ;Done!


nofile:
    ret

datastring:
    .db $0C,6,"bbdata"

LevelTxt:
    .db "Level: ",0
LivesTxt:
    .db "Lives: ",0
    
;======================
;         Code
;======================
#include "bub_main.asm"
#include "bub_ai.asm"
#include "bub_draw.asm"


;Sprite Routine
#include "spr21a.inc"

#include "stuff.h"

;======================
;         Data
;======================
#include "bbdata.inc"   ;symboltable
