;#######################
;## Direct Input Keys ##
;#######################

;Group 1
KeyRow_Pad  .equ 0feh
KDown   .equ 254
KLeft   .equ 253
KRight  .equ 251
KUp     .equ 247
KIDown  .equ 1
KILeft  .equ 2
KIRight .equ 4
KIUp    .equ 8



;Group 2
KeyRow_5    .equ 0fdh
KEnter      .equ 254
KPlus       .equ 253
KMinus      .equ 251
KMul        .equ 247
KDiv        .equ 239
KPower      .equ 223
KClear      .equ 191

;Group 3
KeyRow_4    .equ 0fbh
KMinus2     .equ 254
KThree      .equ 253
KSix        .equ 251
KNine       .equ 247
KRbracket   .equ 239
KTan        .equ 223
KVars       .equ 191

;Group 4
KeyRow_3    .equ 0f7h
KPoint      .equ 254
KTwo        .equ 253
KFive       .equ 251
KEight      .equ 247
KLbracket   .equ 239
KCos        .equ 223
KPrgm       .equ 191
KStat       .equ 127

;Group 5
KeyRow_2    .equ 0efh
KZero       .equ 254
KOne        .equ 253
KFour       .equ 251
KSeven      .equ 247
KComma      .equ 239
KSin        .equ 223
KMatrx      .equ 191
KApps       .equ 191
KX      .equ 127

;Group 6
KeyRow_1    .equ 0dfh
KOn         = 254
KSto        .equ 253
KLn     .equ 251
KLog        .equ 247
KX2     .equ 239
KX-1        .equ 223
KMath       .equ 191
KAlpha      .equ 127
KIOn    = 1
KIMath  = 64
KIAlpha = 128


;Group 7
KeyRow_Top  .equ 0bfh
KGraph      .equ 254
KTrace      .equ 253
KZoom       .equ 251
KWindow     .equ 247
KY      .equ 239
K2nd        .equ 223
KMode       .equ 191
KDel        .equ 127

KI2nd = 32
KIMode = 64
KIDel = 128



IonFastCopy:
    ld hl,_plotSScreen
    ld de,$FC00
	ld bc,1024
	ldir
    ret

MakeBlackRight:
	ld hl,$AF80+12				;_plotSScreen+12
	ld a,255
	ld c,64
	ld de,12
MakeBlackRightLoop1:
	ld b,4
MakeBlackRightLoop2:
	ld (hl),a
	inc hl
	djnz MakeBlackRightLoop2
	add hl,de
	dec c
	jr nz,MakeBlackRightLoop1
	ret

PauseGame:
	;set textInverse,(iy+textflags)
	ld hl,$0403
	ld (_curRow),hl
	ld hl,PauseText
	call _puts
	ld b,50
PrePauseLoop:
	halt
	djnz PrePauseLoop
PauseGameLoop:
	halt
    ld a,255
    out (1),a
    ld a,KeyRow_Top
    out (1),a
    in a,(1)
    cpl
    and KIDel
	jr z,PauseGameLoop
	ld b,50
PostPauseLoop:
	halt
	djnz PostPauseLoop
	xor a
	ld (IntCounter),a
	;res textInverse,(iy+textflags)
	jp IonFastCopy

InstallInt:
    res alt_int,(iy+exceptionflg)
    ld hl,IntCodeStart
    ld de,_alt_interrupt_exec
    ld bc,IntCodeEnd-IntCodeStart
    ldir
    ld b,5
    ld hl,_alt_int_chksum
    ld de,40
    ld a,(_alt_interrupt_exec)
InstIntLoop:
    add hl,de
    add a,(hl)
    djnz InstIntLoop
    ld (_alt_int_chksum),a
    set alt_int,(iy+exceptionflg)
    ret

IntCodeStart:  
    ld hl,IntCounter
    inc (hl)
    ret
IntCounter = _alt_interrupt_exec + 5
    .db 0
IntCodeEnd:
 
ScoreTxt:
    .db "Score: ",0

PauseText:
	.db " Paused ",0
